functor
import
   Application(exit)
   Property
   Browser(browse: Browse)
   System(showInfo: ShowInfo)

   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   CosieClass('class': Cosie)
   at 'x-ozlib://mathweb/cs/cosie/CosieClass.ozf'

define
   local
      Cos = {New Cosie init({New XApplication.manager init} 'Lim.oz')}
      Sol
      S
   in
      {Cos reset('LIM-PLUS1' _)}
      %{Cos showConstraints(_)}
      %{Cos openDaVinci(_)}
      
      {Cos tellMetaConstraint('not-occurs'('D2'#const 'M_E2'#var ) _)}
      {Cos tellMetaConstraint('not-occurs'('D1'#const 'M_E1'#var ) _)}
      {Cos tellMetaConstraint('not-occurs'('X'#const 'M_D'#var) _)}
      
%      {Cos tellConstraint('L10' ['L12'#'<'(0 'E'#const) ] '<'(0 'D1'#const) _)}
%      {Cos tellConstraint('L24' ['L12'#'<'(0 'E'#const) ] '<'('/'(1 'E'#const) 'M_D'#var) _)}

      %{Cos tellConstraint('dfs' nil '<'('V'#var '^'(2 3)) _)}
      %{Cos tellConstraint('dfs' nil '<'('W'#var 'SQRT'(16)) _)}
      
      {Cos testAssumption('L24' ['L12'#'<'(0 'E'#const) ] '<'(0 'D1'#const) _)}
      {Cos tellAssumption('L24' ['L12'#'<'(0 'E'#const) ] '<'(0 'D1'#const) _)}
      
      {Cos tellAssumption('L33' ['L12'#'<'(0 'E'#const) ] '<'(0 'D2'#const) _)}
      {Cos tellAssumption('L33' ['L12'#'<'(0 'E'#const) ] '<'(0 'D2'#const) _)}

      {Cos tellConstraint('L14' ['L12'#'<'(0 'E'#const) ] '<'(0 'M_D'#var) _)}		
      %{Cos testConstraint('l00' nil 'IN'('M_D'#var 'NAT') _)}
      %{Cos tellConstraint('l00' nil 'IN'('M_D'#var 'NAT') _)}

      {Cos testConstraint('L23' ['L12'#'<'(0 'E'#const) ] '<'(0 'M_E1'#var) _)}
      {Cos tellConstraint('L23' ['L12'#'<'(0 'E'#const) ] '<'(0 'M_E1'#var) _)}

      {Cos testConstraint('L32' ['L12'#'<'(0 'E'#const) ] '<'(0 'M_E2'#var) _)}
      {Cos tellConstraint('L32' ['L12'#'<'(0 'E'#const) ] '<'(0 'M_E2'#var) _)}
 
      {Cos testConstraint('L41' ['L12'#'<'(0 'E'#const) ] '<'(0 'M_C'#var) _)}
      {Cos tellConstraint('L41' ['L12'#'<'(0 'E'#const) ] '<'(0 'M_C'#var) _)}
 
      {Cos testConstraint('L38' ['L12'#'<'(0 'E'#const) ] '<='('||'(1) 'M_C'#var) _)}
      {Cos tellConstraint('L38' ['L12'#'<'(0 'E'#const) ] '<='('||'(1) 'M_C'#var) _)}

      {Cos testConstraint('L43' ['L12'#'<'(0 'E'#const) ] '<='('M_E2'#var '/'('E'#const 2)) _)}
      {Cos tellConstraint('L43' ['L12'#'<'(0 'E'#const) ] '<='('M_E2'#var '/'('E'#const 2)) _)}

      {Cos testConstraint('L42' ['L12'#'<'(0 'E'#const) ] '='('M_X2'#var 'X'#const) _)}
      {Cos tellConstraint('L42' ['L12'#'<'(0 'E'#const) ] '='('M_X2'#var 'X'#const) _)}

      {Cos askConstraint('L51' ['L12'#'<'(0 'E'#const) ] '<='(0 0) _)}
      {Cos askConstraint('L55' ['L12'#'<'(0 'E'#const) ] '<='(0 0) _)}
 
      {Cos tellConstraint('L49' ['L12'#'<'(0 'E'#const) ] '<='('M_E1'#var '/'('E'#const '*'(2 'M_C'#var))) _)}
 
      {Cos tellConstraint('L48' ['L12'#'<'(0 'E'#const) ] '='('M_X1'#var 'X'#const) _)}

      {Cos tellConstraint('L50' ['L12'#'<'(0 'E'#const) ] '='('M_X1'#var 'X'#const) _)}

      {Cos tellConstraint('L53' ['L12'#'<'(0 'E'#const) ] '<='('M_D'#var 'D1'#const) _)}

      {Cos tellConstraint('L52' ['L12'#'<'(0 'E'#const) ] '='('M_X1'#var 'X'#const) _)}
      {Cos tellConstraint('L54' ['L12'#'<'(0 'E'#const) ] '='('M_X2'#var 'X'#const) _)}
      {Cos tellConstraint('L57' ['L12'#'<'(0 'E'#const) ] '<='('M_D'#var 'D2'#const) _)}
      {Cos testConstraint('L56' ['L12'#'<'(0 'E'#const) ] '='('M_X2'#var 'X'#const) _)}
      {Cos tellConstraint('L56' ['L12'#'<'(0 'E'#const) ] '='('M_X2'#var 'X'#const) _)}

      {ShowInfo {Cos eigenVars($)}}
      S={Cos reflect($)}
      {ShowInfo S}
      
      Sol = {Cos findSolution($)}
      
      {ShowInfo Sol}
% G={Cos merge($)}
%      S={Cos browse($)}
      %{Application.exit 0}
   end
end

